%define ocamlname cstruct-lwt

Name:           ocaml-%{ocamlname}
Version:        3.2.1
Release:        1%{?dist}.emp1
Summary:        Access C-like structures directly from OCaml
License:        ISC
URL:            https://github.com/mirage/ocaml-cstruct
Source0:        https://github.com/mirage/ocaml-cstruct/releases/download/v3.2.1/cstruct-3.2.1.tbz

Requires:       ocaml >= 4.03.0
Requires:       ocaml-cstruct
Requires:       ocaml-lwt

BuildRequires:  opam-installer >= 2.0
BuildRequires:  jbuilder
BuildRequires:  ocaml >= 4.03.0
BuildRequires:  ocaml-cstruct-devel
BuildRequires:  ocaml-lwt-devel

%description
Cstruct is a library and syntax extension to make it easier to access
C-like structures directly from OCaml. It supports both reading and
writing to these structures, and they are accessed via the Bigarray
module.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       ocaml-cstruct-devel
Requires:       ocaml-lwt-devel

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%setup -q -n cstruct-%{version}

%build
jbuilder build  -p %{ocamlname} %{?_smp_mflags}

%install
opam-installer \
	--prefix=%{buildroot}/%{_libdir}/ocaml \
	--libdir=%{buildroot}/%{_libdir}/ocaml \
	%{ocamlname}.install

%check
jbuilder runtest  -p %{ocamlname} %{?_smp_mflags}

%files
%doc LICENSE.md
%{_libdir}/ocaml/%{ocamlname}
%ifarch %{ocaml_native_compiler}
%exclude %{_libdir}/ocaml/%{ocamlname}/*.a
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmxa
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%exclude %{_libdir}/ocaml/%{ocamlname}/*.mli


%files devel
%doc CHANGES.md README.md
%doc %{_libdir}/ocaml/doc/%{ocamlname}/*
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{ocamlname}/*.a
%{_libdir}/ocaml/%{ocamlname}/*.cmxa
%{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%{_libdir}/ocaml/%{ocamlname}/*.mli
